Package org.apache.tapestry5.internal.services

## Class EnvironmentalShadowBuilderImpl

- java.lang.Object
- - org.apache.tapestry5.internal.services.EnvironmentalShadowBuilderImpl

- All Implemented Interfaces:
    `EnvironmentalShadowBuilder`

      public class EnvironmentalShadowBuilderImpl
      extends java.lang.Object
      implements EnvironmentalShadowBuilder

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EnvironmentalShadowBuilderImpl​(PlasticProxyFactory proxyFactory, Environment environment)` | Construct using the default builtin factory, not the component layer version.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<T> T` | `build​(java.lang.Class<T> serviceType)` | Returns a proxy that delegates all methods to an object obtained from `Environment.peekRequired(Class)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EnvironmentalShadowBuilderImpl

          public EnvironmentalShadowBuilderImpl​(@Builtin
                                                PlasticProxyFactory proxyFactory,
                                                Environment environment)

      Construct using the default builtin factory, not the component layer version.

  - ### Method Detail

    - #### build

          public <T> T build​(java.lang.Class<T> serviceType)

      Description copied from interface: `EnvironmentalShadowBuilder`
      Returns a proxy that delegates all methods to an object obtained from `Environment.peekRequired(Class)`. Note that at the time this method is invoked, the Environment service may still be virtual, and will often not yet have been loaded with values, and that's OK, the resolution is deferred to the instant a method is invoked.
      Specified by:
        `build` in interface `EnvironmentalShadowBuilder`
      Parameters:
        `serviceType` - the service type, which is used to obtained the delegate instance
      Returns:
        a proxy to the service